# countdown.tcl -- countdown timer implementation.

# $Id: countdown.tcl,v 1.2 2003/10/27 16:33:15 davidw Exp $

package provide countdown 0.1

namespace eval ::countdown {
    set seconds 0
    set started 0
    set starttime 0
    set paused 0
}

proc ::countdown::start {time} {
    variable started
    variable multiple
    variable starttime
    variable seconds
    variable paused

    if { $time == 0 } {
	return
    }

    if { $paused } {
	::countdown::gui::unpause
	set paused 0
    }

    if { $started == 0 } {
	set starttime $time
	set seconds $time
	starttimer
	set started 1
    } else {
	starttimer
    }
}

proc ::countdown::pause {} {
    variable paused

    set paused 1
    stoptimer
    ::countdown::gui::pause
}

proc ::countdown::dotimer {} {
    variable seconds

    incr seconds -1
    ::countdown::gui::Update $seconds
    if { $seconds <= 0 } {
	::countdown::gui::timeup
	return
    }
    starttimer
}

proc ::countdown::starttimer {} {
    after [expr 1000] ::countdown::dotimer
}

proc ::countdown::stoptimer {} {
    foreach Id [after info] {
	after cancel $Id
    }
}

proc ::countdown::reset {} {
    variable started
    variable seconds
    variable starttime

    set started 0
    set seconds 0
    stoptimer
    ::countdown::gui::reset $starttime
    update
}

proc ::countdown::getstart {} {
    variable starttime
    return $starttime
}
